DEF VAR cQuery         AS CHAR   NO-UNDO.
DEF VAR hQuery         AS HANDLE NO-UNDO.
DEF VAR hBuffer        AS HANDLE NO-UNDO.
DEF VAR hField         AS HANDLE NO-UNDO.
DEF VAR cList          AS CHAR   NO-UNDO.
DEF VAR iLoop          AS INT    NO-UNDO.
DEF VAR iField         AS INT    NO-UNDO.
DEF VAR iCount         AS INT    NO-UNDO.
DEF VAR iSearch        AS INT    NO-UNDO.
DEF VAR cTable         AS CHAR   NO-UNDO.
DEF VAR cFieldList     AS CHAR   NO-UNDO.
DEF VAR cField         AS CHAR   NO-UNDO.
DEF VAR cValue         AS CHAR   NO-UNDO.
DEF VAR hPrint_win     AS HANDLE NO-UNDO.
DEF VAR cSearch        AS CHAR   NO-UNDO EXTENT 6. 
DEF VAR cReplace       AS CHAR   NO-UNDO EXTENT 6. 
DEF VAR cOld           AS CHAR   NO-UNDO. 
DEF VAR cNew           AS CHAR   NO-UNDO. 
DEF VAR cNewValue      AS CHAR   NO-UNDO. 
DEF VAR cMissing       AS CHAR   NO-UNDO. 
DEF VAR cMissing2      AS CHAR   NO-UNDO. 
DEF VAR cContainer     AS CHAR   NO-UNDO. 
DEF VAR lDelete        AS LOG    NO-UNDO.
DEF VAR cOrgValue      AS CHAR   NO-UNDO. 
DEF VAR cSaveValue     AS CHAR   NO-UNDO. 
DEF VAR rRowid         AS ROWID  NO-UNDO.

cList =  "ec-agent-line"        + "," + "linecode"
      + ",ec-container"         + "," + "act_linecode"
      + ",ec-container_history" + "," + "linecode+ext_linecode"
      + ",ec-dropoff"           + "," + "linecode"
      + ",ec-log-changes"       + "," + "linecode+ext_linecode"
      + ",ec-parameter"         + "," + "agent_linecode"
      + ",ec-pickup"            + "," + "linecode"
      + ",ec-release"           + "," + "linecode"
      + ",ec-status"            + "," + "linecode"
      + ",ec-total_info"        + "," + "linecode"
      + ",ec-webuser-line"      + "," + "linecode"
      + ",ec-line-lease"        + "," + "linecode"
      + ",ec-line"              + "," + "linecode" 
      . 

/* Country codes */
cSearch[1]  =       "BBL" 
            + "," + "EU"
            + "," + "EUSHORT"
            + "," + "HYU"
            + "," + "SYNCHRO"
            + "," + "ISCONT"
            + "," + "SHI-OWN"
            + "," + "SYN/BIO"
            + "," + "SYN/CHINA"
            + "," + "TEMP"
            + "," + "NIRINT"
            .
cReplace[1] =       "BBLI-L-MOE" 
            + "," + "ECCE-L-MOE"
            + "," + "ECCE-S-MOE"
            + "," + "ECCE-P-MOE"
            + "," + "ECCE-P-MOE"
            + "," + "ISCO-P-MOE"
            + "," + "SHOW-S-HAV"
            + "," + "ECCE-P-BIO"
            + "," + "ECCE-P-XGG"
            + "," + "ECCE-S-MOE"
            + "," + "NIRU-L-MOE"
            .

DEF TEMP-TABLE updated-records NO-UNDO
         FIELD cTable AS CHAR  
         FIELD rRowid AS ROWID 
         INDEX updated-records IS PRIMARY cTable 
                                          rRowid .


RUN system/w-sp-print-update.w PERSISTENT SET hPrint_win.
RUN initializeObject IN hPrint_win.

DO iLoop = 1 TO NUM-ENTRIES(cList) BY 2:
  cTable     = ENTRY(iLoop,cList).
  cFieldList = REPLACE(ENTRY(iLoop + 1,cList),"+",",").
  
  iCount = 0.
  RUN spUpdate IN hPrint_win (INPUT ""
                             ,INPUT iCount
                             ,INPUT "Converting " + cTable + "..." ).
  
  trans-blok:
  DO /* TRANSACTION ON ERROR UNDO trans-blok,LEAVE trans-blok */:
    CREATE BUFFER hBuffer FOR TABLE cTable.
    hBuffer:DISABLE-LOAD-TRIGGERS(TRUE).
    cQuery = "FOR EACH " + cTable + " no-lock " .
           
    hField = hBuffer:BUFFER-FIELD('companycode') NO-ERROR.
    IF VALID-HANDLE(hField)
    THEN DO:
      cQuery = cQuery + " WHERE " + cTable + ".companycode = 'NIR': ".
    END.
    
    CREATE QUERY hQuery.
    hQuery:SET-BUFFERS(hBuffer).
    hQuery:QUERY-PREPARE(cQuery).
    hQuery:QUERY-OPEN().
    hQuery:GET-FIRST(NO-LOCK).
    EMPTY TEMP-TABLE updated-records.
    DO WHILE NOT hQuery:QUERY-OFF-END /* ON ERROR UNDO trans-blok,LEAVE trans-blok */:
      cSaveValue = "".
      rRowid     = ?.
      FIELD-blok:
      DO iField = 1 TO NUM-ENTRIES(cFieldList) /* ON ERROR UNDO trans-blok,LEAVE trans-blok */:
        cField = ENTRY(iField,cFieldList).
        hField = hBuffer:BUFFER-FIELD(cField) NO-ERROR.
        IF VALID-HANDLE(hField) 
        THEN DO:
          cValue    = hField:BUFFER-VALUE.
          cOrgValue = cValue.
          IF   cValue <> "" AND cValue <> ?
           AND CAN-FIND(updated-records NO-LOCK WHERE 
                        updated-records.cTABLE = cTable
                    AND updated-records.rROWID  = hBuffer:ROWID)
          THEN LEAVE FIELD-blok.
          
          IF cValue <> "" AND cValue <> ? 
          THEN DO:
            
            cOld = cSearch[1].
            cNew = cReplace[1].
            iSearch = LOOKUP(cValue,cOld).
            
            IF iSearch > 0 
            THEN DO:
              cNewValue = ENTRY(iSearch,cNew).
              
              IF cNewValue = "??" 
               AND LOOKUP(cValue,cMissing) = 0
              THEN cMissing = cMissing + cValue + ",".
              IF cNewValue = "???" 
               AND LOOKUP(cvalue,cMissing2) = 0
              THEN cMissing2 = cMissing2 + cValue + ",".
              
              IF   cNewValue <> "??" 
               AND cNewValue <> "???" 
              THEN DO:
                lDelete = FALSE.
                /* nieuwe waarde terugschrijven */
                RUN update-record.
              END.
              
            END.
            ELSE DO:
              IF LOOKUP(cValue,cMissing) = 0
               AND LOOKUP(cValue,cReplace[1]) = 0
              THEN cMissing = cMissing + cValue + ",".
              /*
              MESSAGE "Value" cValue "for field" cField "in" cTable "is unknown." SKIP
                       VIEW-AS ALERT-BOX INFO BUTTONS OK.
              */         
            END.
          
          END.
        END.
        ELSE DO:
          MESSAGE "Field" cField "for table" cTable "is unknown."
                  VIEW-AS ALERT-BOX INFO BUTTONS OK.
        END.
      END.
      
     /* IF LOOKUP(cTable,"ec-total_info") > 0
      THEN */ DO:
        CREATE updated-records.
        ASSIGN updated-records.cTABLE = cTable
               updated-records.rRowid = hBuffer:ROWID. 
      END.
      
      iCount = iCount + 1.
      IF iCount MOD 1000 = 0 
      THEN  RUN spUpdate IN hPrint_win (INPUT ""
                                       ,INPUT iCount
                                       ,INPUT "Converting " + cTable + "..." ).
      
      /* IF rRowid <> ? 
      THEN hQuery:REPOSITION-TO-ROWID(rRowid). */
      hQuery:GET-NEXT(NO-LOCK).
    END.
    DELETE OBJECT hBuffer.
    DELETE OBJECT hQuery.
  END.
END.

RUN spFinished IN hPrint_win.

MESSAGE "1:" cMissing  SKIP 
        "2:" cMissing2 .

PROCEDURE update-record:

  DO TRANSACTION:
    hQuery:GET-CURRENT(EXCLUSIVE).
    hField = hBuffer:BUFFER-FIELD(cField) NO-ERROR.
    hField:BUFFER-VALUE = cNewValue. 
  END.
  
END.



